framework 27 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833
  1. #!/bin/sh -- # no runable script, just for vi
  2. # we all like colorful messages
  3. if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
  4. expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
  5. CERROR="" # red
  6. CWARNING="" # yellow
  7. CMSG="" # green
  8. CINFO="" # light blue
  9. CDEBUG="" # blue
  10. CNORMAL="" # default system console color
  11. CDONE="" # green
  12. CPASS="" # green
  13. CFAIL="" # red
  14. CCMD="" # pink
  15. fi
  16. msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
  17. msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
  18. msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
  19. msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
  20. msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
  21. msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
  22. msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
  23. msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
  24. msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
  25. msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
  26. msgtest() {
  27. while [ -n "$1" ]; do
  28. echo -n "${CINFO}$1${CCMD} " >&2;
  29. echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
  30. shift
  31. if [ -n "$1" ]; then shift; else break; fi
  32. done
  33. echo -n "…${CNORMAL} " >&2;
  34. }
  35. msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
  36. msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
  37. msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
  38. # enable / disable Debugging
  39. MSGLEVEL=${MSGLEVEL:-3}
  40. if [ $MSGLEVEL -le 0 ]; then
  41. msgdie() { true; }
  42. fi
  43. if [ $MSGLEVEL -le 1 ]; then
  44. msgwarn() { true; }
  45. msgnwarn() { true; }
  46. fi
  47. if [ $MSGLEVEL -le 2 ]; then
  48. msgmsg() { true; }
  49. msgnmsg() { true; }
  50. msgtest() { true; }
  51. msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
  52. msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
  53. if [ -n "$CFAIL" ]; then
  54. msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
  55. else
  56. msgfail() { echo -n " ###FAILED###" >&2; }
  57. fi
  58. fi
  59. if [ $MSGLEVEL -le 3 ]; then
  60. msginfo() { true; }
  61. msgninfo() { true; }
  62. fi
  63. if [ $MSGLEVEL -le 4 ]; then
  64. msgdebug() { true; }
  65. msgndebug() { true; }
  66. fi
  67. msgdone() {
  68. if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
  69. [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
  70. [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
  71. [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
  72. [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
  73. true;
  74. else
  75. echo "${CDONE}DONE${CNORMAL}" >&2;
  76. fi
  77. }
  78. runapt() {
  79. msgdebug "Executing: ${CCMD}$*${CDEBUG} "
  80. if [ -f ./aptconfig.conf ]; then
  81. APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
  82. elif [ -f ../aptconfig.conf ]; then
  83. APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
  84. else
  85. LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
  86. fi
  87. }
  88. aptconfig() { runapt apt-config $*; }
  89. aptcache() { runapt apt-cache $*; }
  90. aptget() { runapt apt-get $*; }
  91. aptftparchive() { runapt apt-ftparchive $*; }
  92. aptkey() { runapt apt-key $*; }
  93. aptmark() { runapt apt-mark $*; }
  94. dpkg() {
  95. $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
  96. }
  97. aptitude() {
  98. if [ -f ./aptconfig.conf ]; then
  99. APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
  100. elif [ -f ../aptconfig.conf ]; then
  101. APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
  102. else
  103. LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
  104. fi
  105. }
  106. gdb() {
  107. echo "gdb: run »$*«"
  108. APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
  109. }
  110. addtrap() {
  111. CURRENTTRAP="$CURRENTTRAP $1"
  112. trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
  113. }
  114. setupenvironment() {
  115. TMPWORKINGDIRECTORY=$(mktemp -d)
  116. TESTDIRECTORY=$(readlink -f $(dirname $0))
  117. msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
  118. BUILDDIRECTORY="${TESTDIRECTORY}/../../build/bin"
  119. test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
  120. local OLDWORKINGDIRECTORY=$(pwd)
  121. addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
  122. cd $TMPWORKINGDIRECTORY
  123. mkdir rootdir aptarchive keys
  124. cd rootdir
  125. mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
  126. mkdir -p var/cache var/lib var/log
  127. mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
  128. touch var/lib/dpkg/available
  129. mkdir -p usr/lib/apt
  130. ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
  131. cd ..
  132. local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
  133. if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
  134. cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
  135. fi
  136. local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
  137. if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
  138. cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
  139. fi
  140. cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
  141. ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
  142. echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
  143. echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
  144. echo "Debug::NoLocking \"true\";" >> aptconfig.conf
  145. echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
  146. echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
  147. echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
  148. echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
  149. echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
  150. echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
  151. echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
  152. if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
  153. echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
  154. fi
  155. echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
  156. echo 'quiet::NoUpdate "true";' >> aptconfig.conf
  157. export LC_ALL=C
  158. export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
  159. msgdone "info"
  160. }
  161. getarchitecture() {
  162. if [ "$1" = "native" -o -z "$1" ]; then
  163. eval `aptconfig shell ARCH APT::Architecture`
  164. if [ -n "$ARCH" ]; then
  165. echo $ARCH
  166. else
  167. dpkg --print-architecture
  168. fi
  169. else
  170. echo $1
  171. fi
  172. }
  173. getarchitectures() {
  174. echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
  175. }
  176. configarchitecture() {
  177. local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
  178. rm -f $CONFFILE
  179. echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
  180. shift
  181. while [ -n "$1" ]; do
  182. echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
  183. shift
  184. done
  185. configdpkg
  186. }
  187. configdpkg() {
  188. if [ ! -e rootdir/var/lib/dpkg/status ]; then
  189. local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
  190. if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
  191. cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
  192. else
  193. echo -n > rootdir/var/lib/dpkg/status
  194. fi
  195. fi
  196. if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
  197. local ARCHS="$(getarchitectures)"
  198. if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
  199. DPKGARCH="$(dpkg --print-architecture)"
  200. for ARCH in ${ARCHS}; do
  201. if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
  202. done
  203. if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
  204. # dpkg doesn't really check the version as long as it is fully installed,
  205. # but just to be sure we choose one above the required version
  206. insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
  207. fi
  208. fi
  209. fi
  210. }
  211. setupsimplenativepackage() {
  212. local NAME="$1"
  213. local ARCH="$2"
  214. local VERSION="$3"
  215. local RELEASE="${4:-unstable}"
  216. local DEPENDENCIES="$5"
  217. local DESCRIPTION="$6"
  218. local SECTION="${7:-others}"
  219. local DISTSECTION
  220. if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
  221. DISTSECTION="main"
  222. else
  223. DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
  224. fi
  225. local BUILDDIR=incoming/${NAME}-${VERSION}
  226. mkdir -p ${BUILDDIR}/debian/source
  227. cd ${BUILDDIR}
  228. echo "* most suckless software product ever" > FEATURES
  229. test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
  230. test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
  231. * Initial release
  232. -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
  233. test -e debian/control || echo "Source: $NAME
  234. Section: $SECTION
  235. Priority: optional
  236. Maintainer: Joe Sixpack <joe@example.org>
  237. Build-Depends: debhelper (>= 7)
  238. Standards-Version: 3.9.1
  239. Package: $NAME" > debian/control
  240. if [ "$ARCH" = 'all' ]; then
  241. echo "Architecture: all" >> debian/control
  242. else
  243. echo "Architecture: any" >> debian/control
  244. fi
  245. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
  246. if [ -z "$DESCRIPTION" ]; then
  247. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
  248. If you find such a package installed on your system,
  249. YOU did something horribly wrong! They are autogenerated
  250. und used only by testcases for APT and surf no other propose…" >> debian/control
  251. else
  252. echo "Description: $DESCRIPTION" >> debian/control
  253. fi
  254. test -e debian/compat || echo "7" > debian/compat
  255. test -e debian/source/format || echo "3.0 (native)" > debian/source/format
  256. test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
  257. cd - > /dev/null
  258. }
  259. buildsimplenativepackage() {
  260. local NAME="$1"
  261. local ARCH="$2"
  262. local VERSION="$3"
  263. local RELEASE="${4:-unstable}"
  264. local DEPENDENCIES="$5"
  265. local DESCRIPTION="$6"
  266. local SECTION="${7:-others}"
  267. local PRIORITY="${8:-optional}"
  268. local DISTSECTION
  269. if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
  270. DISTSECTION="main"
  271. else
  272. DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
  273. fi
  274. local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
  275. msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
  276. mkdir -p $BUILDDIR/debian/source
  277. echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
  278. echo "#!/bin/sh
  279. echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
  280. echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
  281. echo "$NAME ($VERSION) $RELEASE; urgency=low
  282. * Initial release
  283. -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
  284. echo "Source: $NAME
  285. Section: $SECTION
  286. Priority: $PRIORITY
  287. Maintainer: Joe Sixpack <joe@example.org>
  288. Standards-Version: 3.9.1
  289. Package: $NAME" > ${BUILDDIR}/debian/control
  290. if [ "$ARCH" = 'all' ]; then
  291. echo "Architecture: all" >> ${BUILDDIR}/debian/control
  292. else
  293. echo "Architecture: any" >> ${BUILDDIR}/debian/control
  294. fi
  295. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
  296. if [ -z "$DESCRIPTION" ]; then
  297. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
  298. If you find such a package installed on your system,
  299. YOU did something horribly wrong! They are autogenerated
  300. und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
  301. else
  302. echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
  303. fi
  304. echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
  305. local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
  306. for SRC in $SRCS; do
  307. echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
  308. done
  309. for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
  310. rm -rf ${BUILDDIR}/debian/tmp
  311. mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
  312. cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
  313. cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
  314. (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
  315. (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
  316. dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
  317. echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
  318. done
  319. mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
  320. cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
  321. cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
  322. rm -rf "${BUILDDIR}"
  323. msgdone "info"
  324. }
  325. buildpackage() {
  326. local BUILDDIR=$1
  327. local RELEASE=$2
  328. local SECTION=$3
  329. local ARCH=$(getarchitecture $4)
  330. msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
  331. cd $BUILDDIR
  332. if [ "$ARCH" = "all" ]; then
  333. ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
  334. fi
  335. local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
  336. local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
  337. local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
  338. cd - > /dev/null
  339. for PKG in $PKGS; do
  340. echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
  341. done
  342. for SRC in $SRCS; do
  343. echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
  344. done
  345. msgdone "info"
  346. }
  347. buildaptarchive() {
  348. if [ -d incoming ]; then
  349. buildaptarchivefromincoming $*
  350. else
  351. buildaptarchivefromfiles $*
  352. fi
  353. }
  354. createaptftparchiveconfig() {
  355. local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
  356. if [ -z "$ARCHS" ]; then
  357. # the pool is empty, so we will operate on faked packages - let us use the configured archs
  358. ARCHS="$(getarchitectures)"
  359. fi
  360. echo -n 'Dir {
  361. ArchiveDir "' >> ftparchive.conf
  362. echo -n $(readlink -f .) >> ftparchive.conf
  363. echo -n '";
  364. CacheDir "' >> ftparchive.conf
  365. echo -n $(readlink -f ..) >> ftparchive.conf
  366. echo -n '";
  367. FileListDir "' >> ftparchive.conf
  368. echo -n $(readlink -f pool/) >> ftparchive.conf
  369. echo -n '";
  370. };
  371. Default {
  372. Packages::Compress ". gzip bzip2 lzma xz";
  373. Sources::Compress ". gzip bzip2 lzma xz";
  374. Contents::Compress ". gzip bzip2 lzma xz";
  375. Translation::Compress ". gzip bzip2 lzma xz";
  376. LongDescription "false";
  377. };
  378. TreeDefault {
  379. Directory "pool/";
  380. SrcDirectory "pool/";
  381. };
  382. APT {
  383. FTPArchive {
  384. Release {
  385. Origin "joesixpack";
  386. Label "apttestcases";
  387. Suite "unstable";
  388. Description "repository with dummy packages";
  389. Architectures "' >> ftparchive.conf
  390. echo -n "$ARCHS" >> ftparchive.conf
  391. echo 'source";
  392. };
  393. };
  394. };' >> ftparchive.conf
  395. for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
  396. echo -n 'tree "dists/' >> ftparchive.conf
  397. echo -n "$DIST" >> ftparchive.conf
  398. echo -n '" {
  399. Architectures "' >> ftparchive.conf
  400. echo -n "$ARCHS" >> ftparchive.conf
  401. echo -n 'source";
  402. FileList "' >> ftparchive.conf
  403. echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
  404. echo -n '";
  405. SourceFileList "' >> ftparchive.conf
  406. echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
  407. echo -n '";
  408. Sections "' >> ftparchive.conf
  409. echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
  410. echo '";
  411. };' >> ftparchive.conf
  412. done
  413. }
  414. buildaptftparchivedirectorystructure() {
  415. local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
  416. for DIST in $DISTS; do
  417. local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
  418. for SECTION in $SECTIONS; do
  419. local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
  420. for ARCH in $ARCHS; do
  421. mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
  422. done
  423. mkdir -p dists/${DIST}/${SECTION}/source
  424. mkdir -p dists/${DIST}/${SECTION}/i18n
  425. done
  426. done
  427. }
  428. insertpackage() {
  429. local RELEASE="$1"
  430. local NAME="$2"
  431. local ARCH="$3"
  432. local VERSION="$4"
  433. local DEPENDENCIES="$5"
  434. local PRIORITY="${6:-optional}"
  435. local ARCHS=""
  436. for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
  437. if [ "$arch" = "all" ]; then
  438. ARCHS="$(getarchitectures)"
  439. else
  440. ARCHS="$arch"
  441. fi
  442. for BUILDARCH in $ARCHS; do
  443. local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
  444. mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
  445. touch aptarchive/dists/${RELEASE}/main/source/Sources
  446. local FILE="${PPATH}/Packages"
  447. echo "Package: $NAME
  448. Priority: $PRIORITY
  449. Section: other
  450. Installed-Size: 42
  451. Maintainer: Joe Sixpack <joe@example.org>
  452. Architecture: $arch
  453. Version: $VERSION
  454. Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
  455. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
  456. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
  457. If you find such a package installed on your system,
  458. YOU did something horribly wrong! They are autogenerated
  459. und used only by testcases for APT and surf no other propose…
  460. " >> $FILE
  461. done
  462. done
  463. }
  464. insertsource() {
  465. local RELEASE="$1"
  466. local NAME="$2"
  467. local ARCH="$3"
  468. local VERSION="$4"
  469. local DEPENDENCIES="$5"
  470. local ARCHS=""
  471. local SPATH="aptarchive/dists/${RELEASE}/main/source"
  472. mkdir -p $SPATH
  473. local FILE="${SPATH}/Sources"
  474. echo "Package: $NAME
  475. Binary: $NAME
  476. Version: $VERSION
  477. Maintainer: Joe Sixpack <joe@example.org>
  478. Architecture: $ARCH" >> $FILE
  479. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
  480. echo "Files:
  481. d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
  482. d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz" >> $FILE
  483. }
  484. insertinstalledpackage() {
  485. local NAME="$1"
  486. local ARCH="$2"
  487. local VERSION="$3"
  488. local DEPENDENCIES="$4"
  489. local PRIORITY="${5:-optional}"
  490. local FILE='rootdir/var/lib/dpkg/status'
  491. local INFO='rootdir/var/lib/dpkg/info'
  492. for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
  493. echo "Package: $NAME
  494. Status: install ok installed
  495. Priority: $PRIORITY
  496. Section: other
  497. Installed-Size: 42
  498. Maintainer: Joe Sixpack <joe@example.org>
  499. Architecture: $arch
  500. Version: $VERSION" >> $FILE
  501. test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
  502. echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
  503. If you find such a package installed on your system,
  504. YOU did something horribly wrong! They are autogenerated
  505. und used only by testcases for APT and surf no other propose…
  506. " >> $FILE
  507. if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
  508. echo -n > ${INFO}/${NAME}:${arch}.list
  509. else
  510. echo -n > ${INFO}/${NAME}.list
  511. fi
  512. done
  513. }
  514. buildaptarchivefromincoming() {
  515. msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
  516. cd aptarchive
  517. [ -e pool ] || ln -s ../incoming pool
  518. [ -e ftparchive.conf ] || createaptftparchiveconfig
  519. [ -e dists ] || buildaptftparchivedirectorystructure
  520. msgninfo "\tGenerate Packages, Sources and Contents files… "
  521. aptftparchive -qq generate ftparchive.conf
  522. cd - > /dev/null
  523. msgdone "info"
  524. generatereleasefiles
  525. }
  526. buildaptarchivefromfiles() {
  527. msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
  528. find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
  529. msgninfo "\t${line} file… "
  530. cat ${line} | gzip > ${line}.gz
  531. cat ${line} | bzip2 > ${line}.bz2
  532. cat ${line} | xz --format=lzma > ${line}.lzma
  533. cat ${line} | xz > ${line}.xz
  534. msgdone "info"
  535. done
  536. generatereleasefiles
  537. }
  538. # can be overridden by testcases for their pleasure
  539. getcodenamefromsuite() { echo -n "$1"; }
  540. getreleaseversionfromsuite() { true; }
  541. getlabelfromsuite() { true; }
  542. generatereleasefiles() {
  543. # $1 is the Date header and $2 is the ValidUntil header to be set
  544. # both should be given in notation date/touch can understand
  545. msgninfo "\tGenerate Release files… "
  546. if [ -e aptarchive/dists ]; then
  547. for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
  548. local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
  549. local CODENAME="$(getcodenamefromsuite $SUITE)"
  550. local VERSION="$(getreleaseversionfromsuite $SUITE)"
  551. local LABEL="$(getlabelfromsuite $SUITE)"
  552. if [ -n "$VERSION" ]; then
  553. VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
  554. fi
  555. if [ -n "$LABEL" ]; then
  556. LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
  557. fi
  558. aptftparchive -qq release $dir \
  559. -o APT::FTPArchive::Release::Suite="${SUITE}" \
  560. -o APT::FTPArchive::Release::Codename="${CODENAME}" \
  561. ${LABEL} \
  562. ${VERSION} \
  563. | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
  564. if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
  565. sed -i '/^Date: / a\
  566. NotAutomatic: yes' $dir/Release
  567. fi
  568. if [ -n "$1" -a "$1" != "now" ]; then
  569. sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
  570. fi
  571. if [ -n "$2" ]; then
  572. sed -i "/^Date: / a\
  573. Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
  574. fi
  575. done
  576. else
  577. aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
  578. fi
  579. if [ -n "$1" -a "$1" != "now" ]; then
  580. for release in $(find ./aptarchive -name 'Release'); do
  581. touch -d "$1" $release
  582. done
  583. fi
  584. msgdone "info"
  585. }
  586. setupdistsaptarchive() {
  587. local APTARCHIVE=$(readlink -f ./aptarchive)
  588. rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
  589. rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
  590. for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
  591. SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
  592. msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
  593. echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
  594. echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
  595. msgdone "info"
  596. done
  597. }
  598. setupflataptarchive() {
  599. local APTARCHIVE=$(readlink -f ./aptarchive)
  600. if [ -f ${APTARCHIVE}/Packages ]; then
  601. msgninfo "\tadd deb sources.list line… "
  602. echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
  603. msgdone "info"
  604. else
  605. rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
  606. fi
  607. if [ -f ${APTARCHIVE}/Sources ]; then
  608. msgninfo "\tadd deb-src sources.list line… "
  609. echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
  610. msgdone "info"
  611. else
  612. rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
  613. fi
  614. }
  615. setupaptarchive() {
  616. buildaptarchive
  617. if [ -e aptarchive/dists ]; then
  618. setupdistsaptarchive
  619. else
  620. setupflataptarchive
  621. fi
  622. signreleasefiles
  623. msgninfo "\tSync APT's cache with the archive… "
  624. aptget update -qq
  625. msgdone "info"
  626. }
  627. signreleasefiles() {
  628. local SIGNER="${1:-Joe Sixpack}"
  629. msgninfo "\tSign archive with $SIGNER key… "
  630. local SECKEYS=""
  631. for KEY in $(find keys/ -name '*.sec'); do
  632. SECKEYS="$SECKEYS --secret-keyring $KEY"
  633. done
  634. local PUBKEYS=""
  635. for KEY in $(find keys/ -name '*.pub'); do
  636. PUBKEYS="$PUBKEYS --keyring $KEY"
  637. done
  638. for RELEASE in $(find aptarchive/ -name Release); do
  639. gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
  640. gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
  641. done
  642. msgdone "info"
  643. }
  644. changetowebserver() {
  645. if which weborf > /dev/null; then
  646. weborf -xb aptarchive/ 2>&1 > /dev/null &
  647. addtrap "kill $!;"
  648. elif which gatling > /dev/null; then
  649. cd aptarchive
  650. gatling -p 8080 -F -S 2>&1 > /dev/null &
  651. addtrap "kill $!;"
  652. cd - > /dev/null
  653. elif which lighttpd > /dev/null; then
  654. echo "server.document-root = \"$(readlink -f ./aptarchive)\"
  655. server.port = 8080
  656. server.stat-cache-engine = \"disable\"" > lighttpd.conf
  657. lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
  658. lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
  659. addtrap "kill $!;"
  660. else
  661. msgdie 'You have to install weborf or lighttpd first'
  662. return 1
  663. fi
  664. local APTARCHIVE="file://$(readlink -f ./aptarchive)"
  665. for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
  666. sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
  667. done
  668. return 0
  669. }
  670. checkdiff() {
  671. local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
  672. if [ -n "$DIFFTEXT" ]; then
  673. echo
  674. echo "$DIFFTEXT"
  675. return 1
  676. else
  677. return 0
  678. fi
  679. }
  680. testfileequal() {
  681. local FILE="$1"
  682. shift
  683. msgtest "Test for correctness of file" "$FILE"
  684. if [ -z "$*" ]; then
  685. echo -n "" | checkdiff $FILE - && msgpass || msgfail
  686. else
  687. echo "$*" | checkdiff $FILE - && msgpass || msgfail
  688. fi
  689. }
  690. testequal() {
  691. local COMPAREFILE=$(mktemp)
  692. addtrap "rm $COMPAREFILE;"
  693. echo "$1" > $COMPAREFILE
  694. shift
  695. msgtest "Test for equality of" "$*"
  696. $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
  697. }
  698. testequalor2() {
  699. local COMPAREFILE1=$(mktemp)
  700. local COMPAREFILE2=$(mktemp)
  701. local COMPAREAGAINST=$(mktemp)
  702. addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
  703. echo "$1" > $COMPAREFILE1
  704. echo "$2" > $COMPAREFILE2
  705. shift 2
  706. msgtest "Test for equality OR of" "$*"
  707. $* 2>&1 1> $COMPAREAGAINST
  708. (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
  709. checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
  710. ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
  711. "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
  712. msgfail )
  713. }
  714. testshowvirtual() {
  715. local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
  716. local PACKAGE="$1"
  717. shift
  718. while [ -n "$1" ]; do
  719. VIRTUAL="${VIRTUAL}
  720. N: Can't select versions from package '$1' as it is purely virtual"
  721. PACKAGE="${PACKAGE} $1"
  722. shift
  723. done
  724. msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
  725. VIRTUAL="${VIRTUAL}
  726. N: No packages found"
  727. local COMPAREFILE=$(mktemp)
  728. addtrap "rm $COMPAREFILE;"
  729. local ARCH="$(getarchitecture 'native')"
  730. echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
  731. aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
  732. }
  733. testnopackage() {
  734. msgtest "Test for non-existent packages" "apt-cache show $*"
  735. local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
  736. if [ -n "$SHOWPKG" ]; then
  737. echo
  738. echo "$SHOWPKG"
  739. msgfail
  740. return 1
  741. fi
  742. msgpass
  743. }
  744. testdpkginstalled() {
  745. msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
  746. local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
  747. if [ "$PKGS" != $# ]; then
  748. echo $PKGS
  749. dpkg -l $* | grep '^[a-z]'
  750. msgfail
  751. return 1
  752. fi
  753. msgpass
  754. }
  755. testdpkgnotinstalled() {
  756. msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
  757. local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
  758. if [ "$PKGS" != 0 ]; then
  759. echo
  760. dpkg -l $* | grep '^[a-z]'
  761. msgfail
  762. return 1
  763. fi
  764. msgpass
  765. }
  766. testmarkedauto() {
  767. local COMPAREFILE=$(mktemp)
  768. addtrap "rm $COMPAREFILE;"
  769. if [ -n "$1" ]; then
  770. msgtest 'Test for correctly marked as auto-installed' "$*"
  771. while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
  772. else
  773. msgtest 'Test for correctly marked as auto-installed' 'no package'
  774. echo -n > $COMPAREFILE
  775. fi
  776. aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
  777. }
  778. pause() {
  779. echo "STOPPED execution. Press enter to continue"
  780. local IGNORE
  781. read IGNORE
  782. }